#!/bin/sh
# fprot definitions updater 0.0.3 - GuestToo - Oct 11, 2005
# 0.0.3: downloads a new definition only if it has changed

URL1='http://updates.f-prot.com/cgi-bin/check-updates?protocol=1&run_as=check_updates'
ID='anonymous'
PASSWD='check-updates@f-prot.com'

MSG=`which gxmessage` || MSG=xmessage
$MSG -buttons "Update:21,Cancel" -center -title "F-prot Updater" " F-prot Updater:
 Connect to the internet
 then click Update "
[ $? -eq 21 ] || exit

cd /root/my-applications/f-prot
if grep 'http:' check-updates
then
    cp -f check-updates check-updates-old
fi
[ -r check-updates-old ] || touch check-updates-old

wget -t 20 --waitretry=20 --http-user=$ID --http-passwd=$PASSWD -O check-updates $URL1

if ! grep 'http:' check-updates
then
    $MSG -bg "#ffc0c0" -center -title "F-prot Updater" " ERROR: downloading information on updates"
    exit 1
fi

URL2=`grep 'S:http://' check-updates | sed 's/^S://'`
URL3=${URL2}sign.zip
URL4=${URL2}sign2.zip
URL5=${URL2}macrdef2.zip

rm -f sign.zip sign2.zip macrdef2.zip

### test $CHKSUM1 = $CHKSUM2 does not seem to work??

CHKSUM1="`grep 'sign\.zip' check-updates-old`"
CHKSUM2="`grep 'sign\.zip' check-updates`"
if ! echo $CHKSUM1 | grep $CHKSUM2 > /dev/null
then
  wget -t 20 --waitretry=20 --http-user=$ID --http-passwd=$PASSWD $URL3
  if ! unzip -t sign.zip
  then
    $MSG -bg "#ffc0c0" -center -title "F-prot Updater" " ERROR: sign.zip File Integrity Check"
    exit 1
  fi
  if ! unzip -o sign.zip
  then
    $MSG -bg "#ffc0c0" -center -title "F-prot Updater" " ERROR: unzipping sign.zip"
    exit 1
  fi
fi

CHKSUM1=`grep 'sign2\.zip' check-updates-old`
CHKSUM2=`grep 'sign2\.zip' check-updates`
if ! echo $CHKSUM1 | grep $CHKSUM2 > /dev/null
then
  wget -t 20 --waitretry=20 --http-user=$ID --http-passwd=$PASSWD $URL4
  if ! unzip -t sign2.zip
  then
    $MSG -bg "#ffc0c0" -center -title "F-prot Updater" " ERROR: sign2.zip File Integrity Check"
    exit 1
  fi
  if ! unzip -o sign2.zip
  then
    $MSG -bg "#ffc0c0" -center -title "F-prot Updater" " ERROR: unzipping sign2.zip"
    exit 1
  fi
fi

CHKSUM1=`grep 'macrdef2\.zip' check-updates-old`
CHKSUM2=`grep 'macrdef2\.zip' check-updates`
if ! echo $CHKSUM1 | grep $CHKSUM2 > /dev/null
then
  wget -t 20 --waitretry=20 --http-user=$ID --http-passwd=$PASSWD $URL5
  if ! unzip -t macrdef2.zip
  then
    $MSG -bg "#ffc0c0" -center -title "F-prot Updater" " ERROR: macrdef2.zip File Integrity Check"
    exit 1
  fi
  if ! unzip -o macrdef2.zip
  then
    $MSG -bg "#ffc0c0" -center -title "F-prot Updater" " ERROR: unzipping macrdef2.zip"
    exit 1
  fi
fi

rm -f sign.zip sign2.zip macrdef2.zip
rm -f SIGN.ASC SIGN2.ASC MACRO.ASC

$MSG -bg "#d0ffd0" -center -title "F-prot Updater" " Antivirus definitions have been updated "
